"""
**********
Exceptions
**********

Base exceptions and errors for microgp4.

"""


class Microgp4Exception(Exception):
    """Base class for exception for microgp4"""


class Microgp4MethodError(Microgp4Exception):
    """Exception class for calling methods on wrong object"""


class Microgp4InvalidVariable(Microgp4Exception):
    """Exception class for wrong variable"""


class Microgp4InvalidVariableType(Microgp4InvalidVariable):
    """Exception class for using a variable with wrong type"""


class Microgp4InvalidMacro(Microgp4Exception):
    """Exception class for invalid macros"""


class Microgp4UndefinedType(Microgp4Exception):
    """Exception class for parsing an undefined type"""


class Microgp4GenerationError(Microgp4Exception):
    """Exception class for the case in which is impossible to end the task due to solution roles or bag luck"""


class Microgp4InvalidSection(Microgp4Exception):
    """Exception class for invalid sections"""


class Microgp4UndefinedSection(Microgp4InvalidSection, Microgp4UndefinedType):
    """Exception class for using an undefined section"""


class Microgp4ViolationConstraint(Microgp4Exception):
    """Exception class for violation constraint"""
