import getopt
import sys

from microgp4 import microgp4

""""
json_test1_folder = os.path.join("..", "json", "example_01")
json_test1_path = os.path.join(json_test1_folder, "sections.json")
result_test1_path = os.path.join(json_test1_folder, "solution.s")

test1_ctg = microgp4.create_solution(json_test1_path)

ctg_test1 = test1_ctg[0]

ctg_test1.dump_solution(path=result_test1_path)
"""


def main(argv):
    input_file = ''
    output_file = ''
    try:
        opts, args = getopt.getopt(argv[1:], "hi:o:", ["ifile=", "ofile="])
    except getopt.GetoptError:
        print(argv[0] + ' -i <input_file> -o <output_file>', '\n')
        sys.exit(2)
    for opt, arg in opts:
        if opt == '-h':
            print(argv[0] + ' -i <input_file> -o <output_file>', '\n')
            sys.exit()
        elif opt in ("-i", "--ifile"):
            input_file = arg

        elif opt in ("-o", "--ofile"):
            output_file = arg

    ctg_list = microgp4.create_solution(input_file)

    if ctg_list is not None and len(ctg_list) > 0:
        ctg = ctg_list[0]
        ctg.dump_solution(path=output_file)
    else:
        sys.exit(3)


if __name__ == "__main__":
    main(sys.argv)
