from logging import Logger, INFO

from networkx import Graph, DiGraph, MultiDiGraph

G = Graph(attr={"graph": 11, 22: "TEST"})
Log = Logger("Graph Test", INFO)

attr = {"aaa": 4, "bbb": "hello", 4: "test"}

test2 = {"attr": attr, "info": 42}

G.add_node(1, attr=attr)
G.add_node("pippo", attr=test2)
node1 = G.nodes[1]
nodeP = G.nodes["pippo"]

type_g = type(G)

print(type_g)

# Log.warning("Graph: %s" % G.graph)
# Log.error("Test")
# Log.error(nodeP["attr"])
# Log.warning(node1["aaa"])
# Log.debug(node1["bbb"])
# Log.info(node1[4])

###

GD = DiGraph(lable={"graph": 42})

GD.add_node("first", attr={1: 1})
GD.add_node("second", attr={2: 2})

GD.add_edge("first", "second", attr={"edge": "test"})
GD.add_edge("second", 5, test=1)

nodes = GD.successors("first")
nodes1 = GD.successors(5)

print(GD.graph)
print(GD.node)
print(GD.adj)

for n in nodes:
    Log.warning("node: %s, label: %s" % (n, GD.nodes[n],))

mdg = MultiDiGraph()

mdg.add_node("node1", attr={"aaa": 2, "test": 1})
mdg.add_node("node2", attr={"test": 2})
mdg.add_edge("node1", "node2", "edge12P", attr={"test": "edge1"})
mdg.add_edge("node1", "node2", "edge12S", attr={"test": "edge2"})

print(mdg.adj)

n12e = mdg.adj["node1"]["node2"]

print(n12e)
